import fetch from "node-fetch"
import crypto from "crypto"

class Moon {
    constructor(publicKey) {
        this.publicKey = publicKey
    }
    createSession(email) {
        return fetch('https://api.moonauth.com/v1/session', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
                'Authorization': this.token,
            },
            body: JSON.stringify({
                email: email,
            }),
        }).then(response => {
            const secret = crypto.randomBytes(32).toString('hex')
            document.cookie = `__moon_ec=${secret}; secure; httponly;`
        })
    }
    getSession(privateKey, lookup) {
        return fetch('https://api.moonauth.com/v1/lookup', {
            method: 'GET',
            headers: {
                'Content-Type': 'application/json',
                'Authorization': this.publickey,
            },
            body: JSON.stringify({
                privateKey: privateKey,
                lookup: lookup,
            }),
        })
    }
    verifySession() {
        return fetch('https://api.moonauth.com/v1/session', {
            method: 'GET',
            headers: {
                'Content-Type': 'application/json',
                'Authorization': this.token,
            },
        })
    }
    deleteSession(privateKey, lookup) {
        return fetch('https://api.moonauth.com/v1/session', {
            method: 'DELETE',
            headers: {
                'Content-Type': 'application/json',
                'Authorization': this.token,
            },
            body: JSON.stringify({
                privateKey: privateKey,
                lookup: lookup,
            }),
        })
    }
}